# Setup Tags
function snake:food/raycast
tag @s add snake_head_dead
execute at @e[tag=spawn_snake_food] run tag @e[tag=snake_head,distance=..0.1] add snake_head_start
execute at @e[tag=spawn_snake_food] run tag @e[tag=snake_center,distance=..0.1] add snake_center_start
execute at @s as @a if score @s SnakeID = @e[tag=snake_head,limit=1,distance=..0.1] SnakeID run tag @s add snake_player_start

# Multiplayer
execute store result score *Multi SnakeCount if entity @e[tag=snake_head_start,tag=multi,tag=play]
execute if score *Multi SnakeCount matches ..2 run tag @e[tag=snake_head_start,tag=multi,tag=play,tag=!snake_head_dead] add snake_death_single
    
# Reset Scores
scoreboard players reset @a[tag=snake_player_start] SnakeID
scoreboard players set @s SnakeDirection 0

# Setup Player
execute at @e[tag=snake_center_start] run tp @a[tag=snake_player_start] ~ ~2 ~
tag @a[tag=snake_player_start] remove snake

# Clear Effects
effect clear @a[tag=snake_player_start] slowness
effect clear @a[tag=snake_player_start] levitation
effect clear @a[tag=snake_player_start] invisibility

# Title
execute as @a[tag=snake_player_start] run title @s title [{"text":"Score: ","color":"gold"},{"score":{"name":"@s","objective":"SnakeLength"},"color":"yellow"}]
execute as @a[tag=snake_player_start] run title @s subtitle [{"text":"High Score: ","color":"dark_aqua"},{"score":{"name":"@s","objective":"SnakeHigh"},"color":"aqua"}]
title @a[tag=snake_player_start] times 0 60 20

# High Score
execute as @a[tag=snake_player_start] if score @s SnakeLength > @s SnakeHigh run scoreboard players operation @s SnakeHigh = @s SnakeLength
execute as @a[tag=snake_player_start] at @s as @e[tag=snake_leaderboard1,limit=1,sort=nearest,distance=..100] at @s run function snake:leaderboard1/update
    
# Effects
execute as @e[tag=snake_player_start] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 1 0.8

# Reset
tag @s remove play
tag @s remove snake_head_dead
tag @e[tag=snake_center_start] remove snake_center_start
tag @a[tag=snake_player_start] remove snake_player_start
kill @e[tag=spawn_snake_food]

# Death Multi
execute as @e[tag=snake_death_single] at @s run function snake:death/single
tag @e[tag=snake_death_single] remove snake_death_single