#---------------------------------------------------------
# This Datapack was made by CommandGeek
# Please do not copy or credit this as your own work!
# Youtube: www.youtube.com/CommandGeek
#---------------------------------------------------------

# Controls
effect give @a[tag=snake] minecraft:slowness 1 5 true
effect give @a[tag=snake] minecraft:levitation 1 255 true
effect give @a[tag=snake] minecraft:invisibility 1 0 true

execute at @e[tag=snake_center] positioned ~ ~30 ~ run tp @a[distance=..3] ~ ~ ~ 0 90

# Destroy Snake
execute as @e[tag=snake_head,tag=!play,scores={SnakeID=1..}] at @s unless block ~ ~ ~ #snake:head run function snake:kill_snake

# Scroll

execute as @a[tag=snake,scores={SnakeCool=..-1}] at @s run function snake:direction

# Time
scoreboard players add @e[tag=snake_head] SnakeTime 10
execute as @e[tag=snake_head,scores={SnakeTime=100..},tag=play] at @s run function snake:move
execute at @e[tag=snake_head,tag=snake_green] run setblock ~ ~ ~ lime_concrete
execute at @e[tag=snake_head,tag=snake_yellow] run setblock ~ ~ ~ yellow_concrete
execute at @e[tag=snake_head,tag=snake_red] run setblock ~ ~ ~ red_concrete
execute at @e[tag=snake_head,tag=snake_blue] run setblock ~ ~ ~ light_blue_concrete
execute as @e[tag=snake_head,scores={SnakeTime=100..}] run scoreboard players operation @s SnakeTime = @s SnakeSpeed

# Cooldown
scoreboard players remove @a[scores={SnakeC1=1..,SnakePosZ=0}] SnakeC1 1
scoreboard players remove @a[scores={SnakeC2=1..,SnakePosX=0}] SnakeC2 1
scoreboard players remove @a[scores={SnakeC3=1..,SnakePosZ=0}] SnakeC3 1
scoreboard players remove @a[scores={SnakeC4=1..,SnakePosX=0}] SnakeC4 1

scoreboard players set @a[scores={SnakeC1=1..,SnakePosZ=1..}] SnakeC1 3
scoreboard players set @a[scores={SnakeC2=1..,SnakePosX=1..}] SnakeC2 3
scoreboard players set @a[scores={SnakeC3=1..,SnakePosZ=..-1}] SnakeC3 3
scoreboard players set @a[scores={SnakeC4=1..,SnakePosX=..-1}] SnakeC4 3

# Death
execute as @e[tag=snake_head,tag=play] at @s unless block ~ ~-1 ~ #snake:board run function snake:death/check
execute as @e[tag=snake_head,tag=play] at @s if entity @e[tag=snake_tail,distance=..0.1] run function snake:death/check
    
# Tail
scoreboard players set @e[tag=snake_head] SnakeCount 0
execute as @e[tag=snake_head] at @e[tag=snake_tail] if score @s SnakeID = @e[tag=snake_tail,limit=1,distance=..0.1] SnakeID run scoreboard players add @s SnakeCount 1
execute as @e[tag=snake_head] at @e[tag=snake_tail] if score @e[tag=snake_tail,limit=1,distance=..0.1] SnakeID = @s SnakeID if score @e[tag=snake_tail,limit=1,distance=..0.1] SnakeLength > @s SnakeLength as @e[tag=snake_tail,limit=1,distance=..0.1] at @s run function snake:kill_tail

# Food
execute as @e[tag=snake_head] at @s store result score @s SnakeFood if entity @e[tag=snake_food,distance=..30]
execute as @e[tag=snake_head,scores={SnakeFood=..3,SnakeDirection=1..}] at @s if predicate snake:food align xz positioned ~0.5 ~ ~0.5 run function snake:food/spawn
    
# Actionbar
execute as @a[tag=snake] run title @s actionbar [{"text":"Score: ","color":"dark_aqua"},{"score":{"name":"@s","objective":"SnakeLength"},"color":"aqua"}]

# Start
execute as @e[tag=snake_start] at @s run function snake:setup/board

# ID Start
execute as @e[tag=snake_head,tag=!play,tag=snake_green] at @s run particle dust 0 1 0 2 ~ ~0.5 ~ 0.3 0.3 0.3 0.1 1
execute as @e[tag=snake_head,tag=!play,tag=snake_yellow] at @s run particle dust 1 0.7 0 2 ~ ~0.5 ~ 0.3 0.3 0.3 0.1 1
execute as @e[tag=snake_head,tag=!play,tag=snake_red] at @s run particle dust 1 0 0 2 ~ ~0.5 ~ 0.3 0.3 0.3 0.1 1
execute as @e[tag=snake_head,tag=!play,tag=snake_blue] at @s run particle dust 0 0.7 1 2 ~ ~0.5 ~ 0.3 0.3 0.3 0.1 1

execute as @e[tag=snake_head,tag=!play,tag=!multi] at @s positioned ~ ~1 ~ unless score @p[distance=..0.5,predicate=snake:sneaking] SnakeID = @s SnakeID run function snake:setup/team/join
    
execute as @a at @e[tag=snake_head,tag=!play,tag=snake_green] if score @s SnakeID = @e[tag=snake_head,limit=1,distance=..0.1] SnakeID run title @s actionbar {"text":"You chose Green Snake","color":"green"}
execute as @a at @e[tag=snake_head,tag=!play,tag=snake_yellow] if score @s SnakeID = @e[tag=snake_head,limit=1,distance=..0.1] SnakeID run title @s actionbar {"text":"You chose Yellow Snake","color":"gold"}
execute as @a at @e[tag=snake_head,tag=!play,tag=snake_red] if score @s SnakeID = @e[tag=snake_head,limit=1,distance=..0.1] SnakeID run title @s actionbar {"text":"You chose Red Snake","color":"red"}
execute as @a at @e[tag=snake_head,tag=!play,tag=snake_blue] if score @s SnakeID = @e[tag=snake_head,limit=1,distance=..0.1] SnakeID run title @s actionbar {"text":"You chose Blue Snake","color":"aqua"}
    
# Team Join
execute unless score *New SnakeID matches 1.. run scoreboard players set *New SnakeID 1
execute if entity @e[tag=new_snake_head] run scoreboard players add *New SnakeID 1
scoreboard players operation @e[tag=new_snake_head] SnakeID = *New SnakeID
tag @e[tag=new_snake_head] remove new_snake_head

# Team Leave
execute as @e[tag=snake_head,tag=!play] at @s at @a[distance=4..] if score @s SnakeID = @p SnakeID run tag @s add snake_leave
execute as @e[tag=snake_head,tag=!play,tag=snake_leave] at @a if score @s SnakeID = @p SnakeID as @p run function snake:setup/team/leave
tag @e[tag=snake_leave] remove snake_leave

# High Score
execute as @a unless score @s SnakeHigh matches 1.. run scoreboard players set @s SnakeHigh 0
    
# Countdown
title @a[scores={SnakeCool=60}] title {"text":"3","color":"green"}
title @a[scores={SnakeCool=60}] subtitle ""
title @a[scores={SnakeCool=60}] times 0 20 5
execute as @a[scores={SnakeCool=60}] at @s run playsound minecraft:block.note_block.pling master @s ~ ~ ~ 1 1

title @a[scores={SnakeCool=40}] title {"text":"2","color":"green"}
title @a[scores={SnakeCool=40}] subtitle ""
title @a[scores={SnakeCool=40}] times 0 20 5
execute as @a[scores={SnakeCool=40}] at @s run playsound minecraft:block.note_block.pling master @s ~ ~ ~ 1 1

title @a[scores={SnakeCool=20}] title {"text":"1","color":"green"}
title @a[scores={SnakeCool=20}] subtitle ""
title @a[scores={SnakeCool=20}] times 0 20 5
execute as @a[scores={SnakeCool=20}] at @s run playsound minecraft:block.note_block.pling master @s ~ ~ ~ 1 1

title @a[scores={SnakeCool=0}] title {"text":"GO!","color":"green"}
title @a[scores={SnakeCool=0}] subtitle ""
title @a[scores={SnakeCool=0}] times 0 20 5
execute as @a[scores={SnakeCool=0}] at @s run playsound minecraft:block.note_block.pling master @s ~ ~ ~ 1 2
execute as @a[scores={SnakeCool=0}] at @e[tag=snake_head] if score @s SnakeID = @e[tag=snake_head,limit=1,distance=..0.1] SnakeID as @e[tag=snake_head,limit=1,distance=..0.1] run scoreboard players set @s SnakeDirection 1

scoreboard players remove @a[scores={SnakeCool=0..}] SnakeCool 1
scoreboard players set @a[scores={SnakeCool=0..},tag=!snake] SnakeCool -1

# Player Leave
execute as @a unless score @s SnakeLeave matches -1 at @s run function snake:leave

# Leaderboard
execute as @e[tag=new_snake_leaderboard1] at @s run function snake:leaderboard1/spawn
execute as @e[tag=new_snake_leaderboard2] at @s run function snake:leaderboard2/spawn