# Setup Tags
function snake:food/raycast
execute at @e[tag=spawn_snake_food] run tag @e[tag=snake_head,distance=..1.2] add snake_head_start
execute at @e[tag=spawn_snake_food] run tag @e[tag=snake_center,distance=..0.1] add snake_center_start
execute as @a at @e[tag=snake_head_start] if score @s SnakeID = @e[tag=snake_head_start,limit=1,distance=..0.1] SnakeID run tag @s add snake_player_start

# Remove
execute at @e[tag=spawn_snake_food] if block ~ ~ ~ player_head run setblock ~ ~ ~ air
execute at @e[tag=snake_head_start] if block ~ ~ ~ #snake:head run setblock ~ ~ ~ air
execute at @e[tag=spawn_snake_food] run kill @e[tag=snake_food,distance=..0.1]
execute at @e[tag=spawn_snake_food] as @e[tag=snake_tail,distance=..0.1] run function snake:kill_tail
    
# Reset Scores
scoreboard players set @e[tag=snake_head_start] SnakeLength 3
scoreboard players set @e[tag=snake_head_start] SnakeSpeed 30
scoreboard players set @e[tag=snake_head_start] SnakeDirection 0
scoreboard players set @a[tag=snake_player_start] SnakeLength 0
scoreboard players set @a[tag=snake_player_start] SnakeCool 100

# Teleport Snake
execute store result score *Players SnakeCount if entity @e[tag=snake_head_start]
execute if score *Players SnakeCount matches 1 at @e[tag=snake_center_start] run tp @s ~ ~ ~
execute if score *Players SnakeCount matches 2.. at @e[tag=snake_center_start] run spreadplayers ~ ~ 2 9 false @e[tag=snake_head_start]

# Multiplayer
execute if score *Players SnakeCount matches 2.. run tag @e[tag=snake_head_start] add multi

# Scroll
execute as @a[tag=snake_player_start] store result score @s SnakeScroll1 run data get entity @s SelectedItemSlot
execute as @a[tag=snake_player_start] store result score @s SnakeScroll2 run data get entity @s SelectedItemSlot
    
# Title
title @a[tag=snake_player_start] title {"text":"Snake","color":"green"}
execute if score *Players SnakeCount matches 1 run title @a[tag=snake_player_start] subtitle {"text":"Singleplayer","color":"dark_green"}
execute if score *Players SnakeCount matches 2.. run title @a[tag=snake_player_start] subtitle {"text":"Multiplayer","color":"dark_green"}
title @a[tag=snake_player_start] times 0 40 20
    
# Setup Player
execute at @e[tag=snake_center_start] run tp @a[tag=snake_player_start] ~ ~30 ~ 0 90
tag @e[tag=snake_player_start] add snake
execute as @a[tag=snake_player_start] at @s run playsound minecraft:block.note_block.pling master @s ~ ~ ~ 1 0

# Starter Food
execute at @e[tag=snake_center_start] run function snake:food/spawn
execute at @e[tag=snake_center_start] run function snake:food/spawn

# Reset Cooldown
scoreboard players set @a[tag=snake_player_start] SnakeC1 0
scoreboard players set @a[tag=snake_player_start] SnakeC2 0
scoreboard players set @a[tag=snake_player_start] SnakeC3 0
scoreboard players set @a[tag=snake_player_start] SnakeC4 0

# Reset
tag @e[tag=snake_head_start] add play
tag @e[tag=snake_head_start] remove snake_head_start
tag @e[tag=snake_center_start] remove snake_center_start
tag @a[tag=snake_player_start] remove snake_player_start
kill @e[tag=spawn_snake_food]